﻿using Microsoft.EntityFrameworkCore.Migrations;

namespace Aya_Backend.Data.Migrations
{
    public partial class InitialFix : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "Users",
                columns: table => new
                {
                    ID = table.Column<int>(nullable: false)
                        .Annotation("Sqlite:Autoincrement", true),
                    Username = table.Column<string>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Users", x => x.ID);
                });

            migrationBuilder.CreateTable(
                name: "Workbooks",
                columns: table => new
                {
                    ID = table.Column<int>(nullable: false)
                        .Annotation("Sqlite:Autoincrement", true),
                    Name = table.Column<string>(nullable: true),
                    OwnerID = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Workbooks", x => x.ID);
                    table.ForeignKey(
                        name: "FK_Workbooks_Users_OwnerID",
                        column: x => x.OwnerID,
                        principalTable: "Users",
                        principalColumn: "ID",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "Workpages",
                columns: table => new
                {
                    ID = table.Column<int>(nullable: false)
                        .Annotation("Sqlite:Autoincrement", true),
                    Name = table.Column<string>(nullable: true),
                    Content = table.Column<string>(nullable: true),
                    WorkbookID = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Workpages", x => x.ID);
                    table.ForeignKey(
                        name: "FK_Workpages_Workbooks_WorkbookID",
                        column: x => x.WorkbookID,
                        principalTable: "Workbooks",
                        principalColumn: "ID",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.InsertData(
                table: "Users",
                columns: new[] { "ID", "Username" },
                values: new object[] { 1, "User1" });

            migrationBuilder.InsertData(
                table: "Users",
                columns: new[] { "ID", "Username" },
                values: new object[] { 2, "User2" });

            migrationBuilder.InsertData(
                table: "Users",
                columns: new[] { "ID", "Username" },
                values: new object[] { 3, "User3" });

            migrationBuilder.InsertData(
                table: "Workbooks",
                columns: new[] { "ID", "Name", "OwnerID" },
                values: new object[] { 1, "Workbook 1", 1 });

            migrationBuilder.InsertData(
                table: "Workbooks",
                columns: new[] { "ID", "Name", "OwnerID" },
                values: new object[] { 2, "Workbook 2", 1 });

            migrationBuilder.InsertData(
                table: "Workbooks",
                columns: new[] { "ID", "Name", "OwnerID" },
                values: new object[] { 3, "Workbook 3", 2 });

            migrationBuilder.InsertData(
                table: "Workbooks",
                columns: new[] { "ID", "Name", "OwnerID" },
                values: new object[] { 4, "Workbook 4", 2 });

            migrationBuilder.InsertData(
                table: "Workbooks",
                columns: new[] { "ID", "Name", "OwnerID" },
                values: new object[] { 5, "Workbook 5", 3 });

            migrationBuilder.InsertData(
                table: "Workpages",
                columns: new[] { "ID", "Content", "Name", "WorkbookID" },
                values: new object[] { 1, "Content 1", "Workpage 1", 1 });

            migrationBuilder.InsertData(
                table: "Workpages",
                columns: new[] { "ID", "Content", "Name", "WorkbookID" },
                values: new object[] { 2, "Content 2", "Workpage 2", 1 });

            migrationBuilder.InsertData(
                table: "Workpages",
                columns: new[] { "ID", "Content", "Name", "WorkbookID" },
                values: new object[] { 3, "Content 3", "Workpage 3", 1 });

            migrationBuilder.InsertData(
                table: "Workpages",
                columns: new[] { "ID", "Content", "Name", "WorkbookID" },
                values: new object[] { 4, "Content 4", "Workpage 4", 1 });

            migrationBuilder.InsertData(
                table: "Workpages",
                columns: new[] { "ID", "Content", "Name", "WorkbookID" },
                values: new object[] { 5, "Content 5", "Workpage 5", 2 });

            migrationBuilder.InsertData(
                table: "Workpages",
                columns: new[] { "ID", "Content", "Name", "WorkbookID" },
                values: new object[] { 6, "Content 6", "Workpage 6", 2 });

            migrationBuilder.InsertData(
                table: "Workpages",
                columns: new[] { "ID", "Content", "Name", "WorkbookID" },
                values: new object[] { 7, "Content 7", "Workpage 7", 3 });

            migrationBuilder.CreateIndex(
                name: "IX_Workbooks_OwnerID",
                table: "Workbooks",
                column: "OwnerID");

            migrationBuilder.CreateIndex(
                name: "IX_Workpages_WorkbookID",
                table: "Workpages",
                column: "WorkbookID");
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "Workpages");

            migrationBuilder.DropTable(
                name: "Workbooks");

            migrationBuilder.DropTable(
                name: "Users");
        }
    }
}
