﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Aya_Backend.Data.Repositories.UserRepositories
{
    public interface IRepository
    {
        //Interface for getting values from a dataset (Database/Mocked data).
        //User
        public User GetUser(int id);
        public User GetUserAuth(string username, string password);
        public User AddUser(User user);
        public void UpdateUser(User user);

        //Workbook
        public Workbook GetWorkbook(int id);
        public Workbook AddWorkbook(string name, int ownerid);
        public List<Workbook> GetUserWorkbooks(int id);

        //Workpage
        public Workpage GetWorkpage(int id);
        public void AddWorkpage(Workpage wp);
        public List<Workpage> GetWorkbookWorkpages(int id);
        public void UpdateWorkbookContent(int id, string content);

        public int GetWorkpageOwnerID(int id);
    }
}
