import API from './API';

export default class WorkpageAPI extends API
{
    private readonly apiPath = "api/workpage/";

    constructor(ax: any, root: string)
    {
        super(ax, root);
    }

    async getAllWorkpagesFromWorkbook(id: string, token: string)
    {
        return await super.getAuthed(this.apiPath + "fromworkbook?id=" + id, token);
    }

    async getWorkpage(id: string, token: string)
    {
        return await super.getAuthed(this.apiPath + "get?id=" + id, token)
    }

    async addWorkpage(name: string, workbookid: number, token)
    {
        return await super.postAuthed(this.apiPath + "add?name=" + name + "&workbookid=" + workbookid, token);
    }

    async updateWorkpage(id: string, content: string, token: string)
    {
        return await super.postAuthedWithBody(this.apiPath + "updateworkpagecontent?id=" + id, '"' + content + '"', token);
    }
}